from PyQt4.QtCore import *
from PyQt4.QtGui import *

import psycopg

from ui_plugingui import Ui_QgsDbSourceSelectBase

import resources

class QgsDbSourceSelectBase(QDialog, Ui_QgsDbSourceSelectBase):
  def __init__(self, parent, fl):
    QDialog.__init__(self, parent, fl)
    
    # set up the user interface from Designer
    self.setupUi(self)
    # populate postgres connections list
    self.populateConnections()

  #def on_btnNew_clicked(self):
  #  #self.addNewConnection()
  #  print "gagugi"


  def populateConnections(self):
    """ populate connections combo box from the qgis.conf settings """
    self.cmbConnections.clear()
    settings = QSettings()
    connGroup = "/PostgreSQL/connections"
    settings.beginGroup(connGroup)
    ## add the default repository when there isn't any...
    ##if len(settings.childGroups()) == 0:
    ##  settings.setValue(self.default_repository_name+"/url", QVariant(self.default_repository))
    for key in settings.childGroups():
      self.cmbConnections.addItem(key)
    settings.endGroup()

  def on_btnConnect_clicked(self):
    # extract parameterers for psycopg from the selected connection
    connName = self.cmbConnections.currentText()
    settings = QSettings()
    
    host = settings.value("/PostgreSQL/connections/"+connName+"/host").toString()
    port = settings.value("/PostgreSQL/connections/"+connName+"/port").toString()
    dbname = settings.value("/PostgreSQL/connections/"+connName+"/database").toString()
    user = settings.value("/PostgreSQL/connections/"+connName+"/username").toString()
    password = settings.value("/PostgreSQL/connections/"+connName+"/password").toString()
    connection = str("host="+host+" port="+port+" dbname="+dbname+" user="+user+" password="+password)
    print connection
    
    #sql = "SELECT * FROM public.geometry_columns"
    #con = psycopg.connect(str(connection))
    #curs = con.cursor()
    #curs.execute(str(sql))
    #con.commit()
    
  #def getConnection(self):
    #if self.cmbConnections.currentIndex() == -1:
    #  return None
    #settings = QSettings()
    #"/PostgreSQL/connections/"
    #reposGroup = "/Qgis/plugin-repos"
    #connGroup = "/PostgreSQL/connections"
    #connName = self.cmbConnections.currentText()
    #= settings.value(selected)
    # self.cmbConnections.currentText()
    #return (connName)
    #print connName

